﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using log4net;

namespace ActivateYourGlutes.Infrastructure.Logging
{
    public class Log4NetLogger : ILogger
    {
        private static readonly ILog _logger = LogManager.GetLogger(typeof(Log4NetLogger));
        #region Implementation of ILogger

        public void Info(string message)
        {
            _logger.Info(message);
        }

        public void Warning(string message)
        {
            _logger.Warn(message);
        }

        public void Error(string message)
        {
            _logger.Error(message);
        }

        public void Error(string message, Exception ex)
        {
            _logger.Error(message, ex);
        }

        public void Fatal(string message)
        {
            _logger.Fatal(message);
        }

        public void Fatal(string message, Exception ex)
        {
            _logger.Fatal(message, ex);
        }

        #endregion
    }
}
