﻿using ActivateYourGlutes.Services.Model;

namespace ActivateYourGlutes.Services
{
    public interface ILocalisationProvider
    {
        /// <summary>
        /// The current unit of length for the user
        /// </summary>
        UnitOfLength UnitOfLength { get; }
        /// <summary>
        /// The current unit of weight for the user
        /// </summary>
        UnitOfWeight UnitOfWeight { get; }
        /// <summary>
        /// Sets the current locale settings in the provider
        /// </summary>
        void SetUserLocaleSettings(UserLocaleSettings settings);
    }
}