﻿using System.Collections.Generic;
using System.Linq;
using ActivateYourGlutes.Data;
using ActivateYourGlutes.Services.Model;
using AutoMapper;

namespace ActivateYourGlutes.Services.Implementation
{
    public class LookupProvider : ProviderBase<Data.Model.UnitOfLength>, ILookupProvider
    {

        public LookupProvider(IEntityModelFactory factory)
            : base(factory)
        {
        }

        #region Implementation of ILookupProvider

        /// <summary>
        /// Returns the units of length that are setup in the system
        /// </summary>
        public IEnumerable<UnitOfLength> UnitsOfLength
        {
            get { return Mapper.Map<List<Data.Model.UnitOfLength>, List<UnitOfLength>>(Repository.Entities.ToList()); }
        }

        /// <summary>
        /// Returns the units of weight that are setup in the system
        /// </summary>
        public IEnumerable<UnitOfWeight> UnitsOfWeight
        {
            get { return Mapper.Map<List<Data.Model.UnitOfWeight>, List<UnitOfWeight>>(GetRepository<Data.Model.UnitOfWeight>().Entities.ToList()); }
        }

        #endregion
    }
}