<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl<BodyEditorPayload>" %>
<%@ Import Namespace="ActivateYourGlutes.Payloads.Body"%>
<%@ Import Namespace="ActivateYourGlutes.Services.Model"%>
<%@ Import Namespace="ActivateYourGlutes.Helpers"%>
<%
    var localeSettings = ViewData.Model.LocaleSettings;
    var dateFormat = localeSettings.DateFormat;
    var jqueryDateFormat = localeSettings.JQueryDateFormat;
    var isEditing = ViewData.Model.EditMode == BodyEditorPayload.EditModeEnum.Edit;
    var measurementTypes = ViewData.Model.MeasurementTypes;
    var body = ViewData.Model.Body;
    var consolidatedBody = ViewData.Model.PreviousBody;

    var validationBuilder = new StringBuilder();
    foreach(var type in measurementTypes)
    {
        var name = type.ToFormName();
        validationBuilder.Append(",");
        validationBuilder.Append(name);
        validationBuilder.Append(": { required:false,min:1");
        if (type.IsPercentage)
            validationBuilder.Append(",max:100");
        validationBuilder.Append(" } ");
    }
%>
<script type="text/javascript">
jQuery.validator.setDefaults({
    debug: false,
    success: "valid"
});
</script>

<script type="text/javascript">
  $(document).ready(function() {
      $("#entryForm").validate({
          rules: {
              EntryDate: {
                  required: true
              }
              <%= validationBuilder.ToString() %>
}/*,
          messages: {
              Weight: {
                  min: "* zzz"
              }
          }*/
          });
      });
</script>

<div id="subheader">
    <h2>Log Measurements</h2>
    <div>            
        <%= Html.ActionLink("Back to Chart", MVC.Body.Index()) %>
        <%= Html.ActionLink("Back to Grid", MVC.Body.Grid()) %>
    </div>
</div>
<%= Html.ValidationSummary() %>
<% using (Html.BeginForm(null, null, null, FormMethod.Post, new { id = "entryForm" }))
   {%>
<%= Html.AntiForgeryToken() %>
<fieldset>        
    <table>
        <tr>
            <td><label for="EntryDate">Date</label></td>
<%
    if (isEditing)
    {
%>
            <td><%=Html.TextBox("EntryDate", Html.Encode(body.EntryDate.ToString(localeSettings.DateFormat)))%></td>
<%
    }
    else
    {
%>
            <td><%= Html.TextBox("EntryDate", DateTime.Now.ToString(dateFormat))%></td>
<%
    }
%>
            <td colspan="4">&nbsp;</td>
        </tr>
        
<%
       int column = 0;
       foreach(var type in measurementTypes)
       {
           var closureType = type;
           if (column == 0)
              Response.Write("<tr>");
           var name = type.ToFormName();
           var value = body.Measurements.Where(m => m.MeasurementType.MeasurementTypeId == closureType.MeasurementTypeId).FirstOrDefault();
           var valueAsString = value == null ? "" : value.LocalisedValue.ToString();
           string unit = "";
           if (type.IsLength)
               unit = localeSettings.UnitOfLength.Unit;
           else if (type.IsWeight)
               unit = localeSettings.UnitOfWeight.Unit;
           else if (type.IsPercentage)
               unit = "%";
           string previousMeasurementString = "";
           if (consolidatedBody != null)
           {
               var previousMeasurement =
                   consolidatedBody.Measurements.Where(
                       m => m.MeasurementType.MeasurementTypeId == closureType.MeasurementTypeId).FirstOrDefault();
               if (previousMeasurement != null)
               {
                   previousMeasurementString = String.Format("({0})", previousMeasurement.LocalisedValue);
               }
           }

%>
            <td><label for="<%= name%>"><%= type.Description%></label></td>
            <td><%= Html.TextBox(name, valueAsString)%></td><td><%= previousMeasurementString %> <%= unit %></td>
<%
           if (column == 1)
               Response.Write("</tr>");
           column++;
           if (column == 2)
               column = 0;
       }
       if (column == 1)
           Response.Write("<td colspan=\"3\">&nbsp;</td></tr>");
%>
    </table>
    <p>
        <input type="submit" value="Save" />
    </p>
</fieldset>
<% } %>

<script type="text/javascript">
    $(function() {
        $("#EntryDate").datepicker({ defaultDate: 0, dateFormat: '<%= jqueryDateFormat %>' });
    });
</script>
